/* Produit matrice*matrice                      */
/* Evaluation du temps d'execution              */  

public class TestProduitMatriceMatrice2 {

/* Fonction de creation d'une matrice de double */
/* initialise avec des nombres aleatoires       */
/* compris dans l'intervalle [0.0,max]          */
/* et un chiffre apres la virgule               */

  static double [][] initRandMatrice(int lignes,int colonnes,double max) {
    double [][] tab = new double[lignes][colonnes];
    for ( int i = 0 ; i < lignes ; i++ ) {
      for ( int j = 0 ; j < colonnes ; j++ ) {
        tab[i][j] = ((int) (Math.random()*max*1000.0))/1000.0; } }
    return tab;
  }

//////////////////////////////////////////////////

/* Fonction de calcul du produit d'un tableau   */
/* de dimension 2 de taille n.n                 */
/* par un tableau de dimension 2 de taille n.n  */
/* Resultat: Un tableau de dimension 2          */
/* de taille n.n                                */

  static void produitMatricesCarrees(double [][] m1,double [][] m2,
                                     double [][] r) {
    int n = m1.length;
    for ( int i = 0 ; i < n ; i++ ) {
      for ( int j = 0 ; j < n ; j++ ) {
        double v = 0.0;
        for ( int k = 0 ; k < n ; k++ ) {
          v += m1[i][k]*m2[k][j]; }
        r[i][j] = v; } }
  }

/* Fonction de calcul du produit d'un tableau   */
/* de dimension 2 de taille n.m                 */
/* par un tableau de dimension 2 de taille m.p  */
/* Resultat: Un tableau de dimension 2          */
/* de taille n.p                                */

  static void produitMatriceMatrice(double [][] m1,double [][] m2,
                                    double [][] r) {
    int n = m1.length;
    int m = m2.length;
    int p = m2[0].length;
    for ( int i = 0 ; i < n ; i++ ) {
      for ( int j = 0 ; j < p ; j++ ) {
        double v = 0.0;
        for ( int k = 0 ; k < m ; k++ ) {
          v += m1[i][k]*m2[k][j]; }
        r[i][j] = v; } }
  }
  
  static void testsProduitMatricesCarrees(int temps,int ni,int nf,
                                          int inc) {
    Ecran.formater("%6s%12s%14s%22s%14s\n",
                   "Taille","Appels","Temps total","Temps moyen",
                   "o(n*n*n)");
    for ( int n = ni ; n <= nf ; n = n+inc ) { {
        double [][] m1 = initRandMatrice(n,n,10.0);
        double [][] m2 = initRandMatrice(n,n,10.0);
        double [][] m = new double[n][n];
        Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          if ( i%2 == 0 )
            produitMatricesCarrees(m1,m2,m);
            else
            produitMatricesCarrees(m2,m1,m);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Ecran.formater("%6d%12d%14d%22.3f%14.4f\n",
                       n,i,t,(double) t/i,
                       ((double) t/i)/((double) n*n*n)); }
      System.gc(); }
  }

  static void testsProduitMatrices(int temps,int ni,int nf,
                                   int inc) {
    Ecran.formater("%18s%12s%14s%22s%14s\n",
                   "Tailles","Appels","Temps total","Temps moyen",
                   "o(n*m*p)");
    for ( int n = ni ; n <= nf ; n = n+inc ) {
      for ( int m = ni ; m <= nf ; m = m+inc ) { 
        for ( int p = ni ; p <= nf ; p = p+inc ) { {
            double [][] m1 = initRandMatrice(n,m,10.0);
            double [][] m2 = initRandMatrice(m,p,10.0);
            double [][] mat = new double[n][p];
            Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
            mntr.temps = temps*1000;
            mntr.lancement();
            long i = 0;
            long ti = System.nanoTime();
            do {
              produitMatriceMatrice(m1,m2,mat);
              i++; }
            while ( mntr.enCours );
            long t = System.nanoTime()-ti;
            Ecran.formater("%6d%6d%6d%12d%14d%22.3f%14.4f\n",
                           n,m,p,i,t,(double) t/i,
                           ((double) t/i)/((double) n*m*p)); }
          System.gc(); } } }
  }

  static void testsProduitMatricesN(int temps,int ni,int nf,
                                    int inc,int m,int p) {
    Ecran.formater("%18s%12s%14s%22s%14s\n",
                   "Tailles","Appels","Temps total","Temps moyen",
                   "o(n*m*p)");
    for ( int n = ni ; n <= nf ; n = n+inc ) { {
        double [][] m1 = initRandMatrice(n,m,10.0);
        double [][] m2 = initRandMatrice(m,p,10.0);
        double [][] mat = new double[n][p];
        Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          produitMatriceMatrice(m1,m2,mat);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Ecran.formater("%6d%6d%6d%12d%14d%22.3f%14.4f\n",
                       n,m,p,i,t,(double) t/i,
                       ((double) t/i)/((double) n*m*p)); }
      System.gc(); }
}

  static void testsProduitMatricesM(int temps,int mi,int mf,
                                    int inc,int n,int p) {
    Ecran.formater("%18s%12s%14s%22s%14s\n",
                   "Tailles","Appels","Temps total","Temps moyen",
                   "o(n*m*p)");
    for ( int m = mi ; m <= mf ; m = m+inc ) { {
        double [][] m1 = initRandMatrice(n,m,10.0);
        double [][] m2 = initRandMatrice(m,p,10.0);
        double [][] mat = new double[n][p];
        Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          produitMatriceMatrice(m1,m2,mat);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Ecran.formater("%6d%6d%6d%12d%14d%22.3f%14.4f\n",
                       n,m,p,i,t,(double) t/i,
                       ((double) t/i)/((double) n*m*p)); }
      System.gc(); }
  }

  static void testsProduitMatricesP(int temps,int pi,int pf,
                                    int inc,int n,int m) {
    Ecran.formater("%18s%12s%14s%22s%14s\n",
                   "Tailles","Appels","Temps total","Temps moyen",
                   "o(n*m*p)");
    for ( int p = pi ; p <= pf ; p = p+inc ) { {
        double [][] m1 = initRandMatrice(n,m,10.0);
        double [][] m2 = initRandMatrice(m,p,10.0);
        double [][] mat = new double[n][p];
        Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          produitMatriceMatrice(m1,m2,mat);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Ecran.formater("%6d%6d%6d%12d%14d%22.3f%14.4f\n",
                       n,m,p,i,t,(double) t/i,
                       ((double) t/i)/((double) n*m*p)); }
      System.gc(); }
  }

//////////////////////////////////////////////////
  
/* Programme principal                          */

  public static void main(String [] args) {
  //  Ecran.afficher("Nombre de secondes de test? ");
  //  int temps = Clavier.saisirInt();
  //  Ecran.afficher("Taille initiale? ");
  //  int ni = Clavier.saisirInt();
  //  Ecran.afficher("Taille finale  ? ");
  //  int nf = Clavier.saisirInt();
  //  Ecran.afficher("Increment      ? ");
  //  int inc = Clavier.saisirInt();
  //  testsRapiditeSurMatricesCarrees(temps,ni,nf,inc);

  //  Ecran.afficher("Nombre de secondes de test? ");
  //  int temps = Clavier.saisirInt();
  //  Ecran.afficher("Taille initiale? ");
  //  int ti = Clavier.saisirInt();
  //  Ecran.afficher("Taille finale  ? ");
  //  int tf = Clavier.saisirInt();
  //  Ecran.afficher("Increment      ? ");
  //  int inc = Clavier.saisirInt();
  //  Ecran.afficherln("Variation de n");
  //  testsProduitMatricesN(temps,ti,tf,inc,500,500);
  //  Ecran.afficherln("Variation de m");
  //  testsProduitMatricesM(temps,ti,tf,inc,500,500);
  //  Ecran.afficherln("Variation de p");
  //  testsProduitMatricesP(temps,ti,tf,inc,500,500);
  
  //  testsProduitMatricesCarrees(60,2,30,1);
  //  testsProduitMatricesCarrees(60,30,815,1);
  //  testsProduitMatricesCarrees(60,815,1000,1);
  //  testsProduitMatricesCarrees(60,0,10000,10);
    testsProduitMatricesCarrees(60,0,10000,100);
  }
}